'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _smoothscrollPolyfill = require('smoothscroll-polyfill');

var _smoothscrollPolyfill2 = _interopRequireDefault(_smoothscrollPolyfill);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);
var getScrollDelta = function getScrollDelta(previousState, y) {
    var diff = y - previousState.y;
    var delta = Math.abs(previousState.delta) < Math.abs(previousState.delta + diff) ? previousState.delta + diff : diff;
    return {
        delta: delta,
        y: y
    };
};

var getScrollPosition = function getScrollPosition() {
    var scrollTop = pageYOffset !== undefined ? pageYOffset : (document.documentElement || document.body.parentNode || document.body).scrollTop;
    return scrollTop < 0 ? 0 : scrollTop;
};

var ReactScrollUpIndicator = function (_React$Component) {
    _inherits(ReactScrollUpIndicator, _React$Component);

    function ReactScrollUpIndicator(props) {
        _classCallCheck(this, ReactScrollUpIndicator);

        var _this = _possibleConstructorReturn(this, (ReactScrollUpIndicator.__proto__ || Object.getPrototypeOf(ReactScrollUpIndicator)).call(this, props));

        _this.firstScroll = true;
        _this.state = {
            active: false
        };
        return _this;
    }

    _createClass(ReactScrollUpIndicator, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (canUseDOM) {
                _smoothscrollPolyfill2.default.polyfill();
                window.addEventListener('scroll', this.onScroll.bind(this), false);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (canUseDOM) {
                window.removeEventListener('scroll', this.onScroll);
            }
        }
    }, {
        key: 'scrollUp',
        value: function scrollUp(e) {
            e.preventDefault();
            window.scroll({
                top: 0,
                left: 0,
                behavior: 'smooth'
            });
        }
    }, {
        key: 'onScroll',
        value: function onScroll() {
            var _this2 = this;

            if (this.firstScroll) {
                this.scrollState = {
                    delta: 0,
                    y: getScrollPosition()
                };
                this.firstScroll = false;
            }

            if (this.isScrolling) {
                return false;
            }

            this.isScrolling = true;
            (0, _raf2.default)(function () {
                _this2.scrollState = getScrollDelta(_this2.scrollState, getScrollPosition());
                _this2.isScrolling = false;
                if (_this2.scrollState.delta < -_this2.props.distance) {
                    _this2.setState({ active: true });
                }

                if (_this2.scrollState.delta > _this2.props.distance || _this2.props.hideAlways >= _this2.scrollState.y) {
                    _this2.setState({ active: false });
                }
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                className = _props.className,
                activeClassName = _props.activeClassName;
            var active = this.state.active;

            var itemClass = className + ' ' + (active ? activeClassName : '');
            return _react2.default.createElement(this.props.tagName, { className: itemClass, onClick: this.scrollUp.bind(this) }, this.props.children);
        }
    }]);

    return ReactScrollUpIndicator;
}(_react2.default.Component);

ReactScrollUpIndicator.defaultProps = {
    tagName: 'div',
    distance: 20,
    hideAlways: 500,
    className: 'indicator',
    activeClassName: 'indicator--inactive'
};

ReactScrollUpIndicator.propTypes = {
    tagName: _propTypes2.default.string.isRequired,
    distance: _propTypes2.default.number.isRequired,
    hideAlways: _propTypes2.default.number.isRequired,
    activeClassName: _propTypes2.default.string.isRequired,
    behavior: _propTypes2.default.string.isRequired,
    className: _propTypes2.default.string.isRequired
};

exports.default = ReactScrollUpIndicator;